/*======================================================================================

	Program:		Range Imaging Toolkit (RITK)
	Module:			ritkRImageIOBase.txx
	Version:		$Revision: 1761 $
	Date:			$Date: 2011-09-23 17:25:41 +0200 (Fr, 23 Sep 2011) $

	Copyright (c) 2010-2011
	Pattern Recognition Lab, 
    University Erlangen-Nuremberg, Germany
    All rights reserved.

	This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
	See RITKCopyright.txt for more information.

	http://www5.informatik.uni-erlangen.de/research/software/ritk

========================================================================================*/

#include "ritkRImageIOBase.h"

namespace ritk
{

template<class TRImageBase>
RImageIOBase<TRImageBase>::
RImageIOBase()
{
}


template<class TRImageBase>
RImageIOBase<TRImageBase>::
~RImageIOBase()
{
}


//----------------------------------------------------------------------------
template<class TRImageBase>
std::string
RImageIOBase<TRImageBase>::
GetFileName()
{
	return m_FileName;
}


//----------------------------------------------------------------------------
template<class TRImageBase>
void
RImageIOBase<TRImageBase>::
SetFileName(std::string FileName)
{
	m_FileName = FileName;
}


//----------------------------------------------------------------------------
template<class TRImageBase>
const std::vector<typename RImageIOBase<TRImageBase>::RImageBaseType::TimeStampType>&
RImageIOBase<TRImageBase>::
GetTimeStamps() const
{
	return m_TimeStamps;
}


//----------------------------------------------------------------------------
template<class TRImageBase>
void
RImageIOBase<TRImageBase>::
Close()
{
  m_FileName = "";
}

} // end namespace ritk


