#include "ritkCudaImage.h"

namespace ritk
{

//----------------------------------------------------------------------------
template<class TPixel, unsigned int VDimension>
CudaImage<TPixel, VDimension>
::CudaImage()
{
	this->SetPixelContainer(ritk::CudaRegularMemoryImportImageContainer<unsigned long, TPixel>::New());
}


//----------------------------------------------------------------------------
template<class TPixel, unsigned int VDimension>
CudaImage<TPixel, VDimension>
::~CudaImage()
{
}


//----------------------------------------------------------------------------
template<class TPixel, unsigned int VDimension>
void
CudaImage<TPixel, VDimension>
::PrintSelf(std::ostream& os, itk::Indent indent) const
{
	os << "CudaImage" << std::endl;
	os << "PixelContainer: " << Superclass::GetPixelContainer() << std::endl;
	Superclass::PrintSelf(os,indent);
} 

} // ritk