/*======================================================================================

	Program:		Range Imaging Toolkit (RITK)
	Module:			ritkTruncatedSignedDistanceFunctionRayCasterEntityControlUnit.h
	Version:		$Revision: 2901 $
	Date:			$Date: 2012-04-03 11:42:33 +0200 (Di, 03 Apr 2012) $

	Copyright (c) 2010-2011
	Pattern Recognition Lab, 
    University Erlangen-Nuremberg, Germany
    All rights reserved.

	This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
	See RITKCopyright.txt for more information.

	http://www5.informatik.uni-erlangen.de/research/software/ritk

========================================================================================*/

#ifndef RITKTRUNCATEDSIGNEDDISTANCEFUNCTIONRAYCASTERENTITYCONTROLUNIT_H__
#define RITKTRUNCATEDSIGNEDDISTANCEFUNCTIONRAYCASTERENTITYCONTROLUNIT_H__

#include "ritkCuda.h"

#include "ui_ritkTruncatedSignedDistanceFunctionRayCasterEntityControlUnit.h"

namespace ritk
{

/**	@ingroup	Cuda
 *	@class		TruncatedSignedDistanceFunctionRayCasterEntityControlUnit
 *	@author		Jakob Wasza
 *	@brief		A controller for TSDF ray casting
 *
 *	@details
 */
class CUDA_EXPORT TruncatedSignedDistanceFunctionRayCasterEntityControlUnit : public QDockWidget, public Ui_TruncatedSignedDistanceFunctionRayCasterEntityControlUnit
{
	Q_OBJECT 

public:
	/// Constructor
	TruncatedSignedDistanceFunctionRayCasterEntityControlUnit( QWidget * parent = 0, Qt::WindowFlags flags = 0 );
	/// Destructor
	~TruncatedSignedDistanceFunctionRayCasterEntityControlUnit();
};

} // ritk


#endif // RITKTRUNCATEDSIGNEDDISTANCEFUNCTIONRAYCASTERENTITYCONTROLUNIT_H__